import java.awt.*;

class Coloree extends Baloune{
    // Baloune remplie avec une couleur
    protected Color couleur;
    
    Coloree(int x, int y, int rayon, Color couleur){
        super(x,y,rayon);
        this.couleur=couleur;
    }
    
    public String toString(){
        return super.toString()+"Couleur="+couleur;
    }
    // comportement chang
    public void afficher(Graphics g, String mess){
        // remplit la couleur avant de faire dessiner le tour et le message en noir
        g.setColor(couleur);
        g.fillOval(x-rayon,y-rayon,2*rayon,2*rayon);
        g.setColor(Color.black);
        super.afficher(g,mess);
    }
}
