import java.awt.*;
class Effacable extends Coloree{
    static private Color fondEcran; // toutes les balounes partagent la
                                    // mme couleur de fond

    Effacable(int x,int y, int rayon,Color couleur){
        super(x,y,rayon,couleur);
    }

    // changement de la variable static
    static public void setFondEcran(Color f){
        fondEcran = f;
    }

    // donner accs aux informations sur la rgion qui entoure la baloune  
    public int gauche(){
        return x-rayon;
    }

    public int haut(){
        return y-rayon;
    }

    public int largeur(){
        return 2*rayon;
    }

    public int hauteur(){
        return 2*rayon;
    }
	
    public void afficher(Graphics g, String mess){
        // affichage "en relief" d'une baloune
        // opration "longue  dessein"
        for(int r = rayon;r>0;r--){
            float degrade = 1-(float)r/(2*rayon);
            g.setColor(new Color((int)(couleur.getRed()*degrade),
                                (int)(couleur.getGreen()*degrade),
                                (int)(couleur.getBlue()*degrade)));
            g.fillOval(x-r,y-r,2*r,2*r);
    	}
    }
	
    public void effacer(Graphics g){
        // redessine le contour avec la couleur du fond
    	g.setColor(fondEcran);
    	g.fillOval(gauche(),haut(),largeur(),hauteur());
    }
}
