import java.awt.*;

class  Face extends Coloree{
    // Baloune colore mais qui s'affiche comme triste ou gaie
    private boolean triste;
    
    Face(int x, int y, int rayon, Color couleur){
        super(x,y,rayon,couleur);
    }
    
    public String toString(){
        return super.toString()+(triste ? "qui pleure":" qui rit" );
    }
    
    // comportement chang
    public void afficher(Graphics g, String mess){
        super.afficher(g,"");
        //  affiche les yeux et le nez 
        int r2=rayon/2, r3=rayon/3, r6=rayon/6;
        g.fillOval(x-r3-r6/2,y-r3,r6,r6);
        g.fillOval(x+r3,y-r3,r6,r6);
        g.fillOval(x-r6/2,y-r6/2,r6,r6);
        if (triste) g.drawArc(x-r2,y+r2,rayon,rayon,50,80); // la moue
        else g.drawArc(x-r2,y-r2,rayon,rayon,230,80);       // le sourire
        // affiche le nom en bas
        g.drawString(mess,x,y+rayon+12);
    }
    
    // comportement spcifique
    public void changeDAir(){
        // passe de triste  gai et inversement
        triste = !triste;
    }    
}
