/**
 * Ce programme sert  montrer la surdfinition et la redfinition
 * des mthodes lors de l'hritage, en Java
 * @author Mohamed Lokbani 
 * @version 1.0
 */


/**
 * Classe de base: A
 */

class A {
    
    /**
       pour afficher un message relatif  la classe A.
       @param n : un entier bidon ...
    */
    public void affiche(int n) {
	System.out.println("classe A: " + n);
    }
    /**
       pour afficher un message relatif  la classe A.
       @param n : un double bidon ...
    */
    public void affiche(float n) {
	System.out.println("classe A: " + n);
    }
}

/**
 * Classe drive : B
 * Hritage  partir de la classe de base : B
 */
class B extends A {

    /**
       pour afficher un message relatif  la classe A.
       @param n : un entier bidon ...
    */
    public void affiche(int n) {
	System.out.println("classe B: " + n);
    }

    /**
       Surdfinition: mme nom, mais signature diffrente.
       peu importe le type de retour
       pour afficher un message relatif  la classe B.
       @param z : un double bidon ...
       @return a <code>boolean</code> pour signifier affichage ok.
    */

    public boolean affiche(double z) {
	System.out.println("classe B: " + z);
	return true;
    }
}

/**
 * classe de test point d'entre pour la
 * machine virtuelle.
 */


public class herredsurd {
    
    public static void main(String [] args) {
	A a = new A();
	B b = new B();

	int w=4; double k=55.9; float zz = 5.3f;

	a.affiche(w); // affiche(int) de A

	// a.affiche(k); // affiche(int) de A => Erreur: impossible de convertir un double vers int ou float

	a.affiche(zz); // affiche(int) de A => Erreur: impossible de convertir un double vers int ou float


	b.affiche(w); // affiche(int) de B

	// b.affiche(zz); // affiche(int) de A ou affiche(double) de B => Erreur : les deux possibilits
	// se trouvent au mme niveau.

	b.affiche(k); // affiche(double) de B

	System.exit(0);
    }
}	
