import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;

public class Balounes extends Applet
    implements MouseListener{
    Baloune b;
    Attachee a;
    Coloree c;
    Face f;
    
    private void trace(String mess){
    	System.out.println(mess);
    }
    
    private void trace(String mess,Baloune b){
    	trace(mess+"="+b);
    }
    
    public void init(){
        addMouseListener(this);
        // oprations sur la baloune de base
        b = new Baloune(200,150,40);
        trace("Cration de b",b);
        b.gonfler(20);
        b.degonfler(30);
	trace("b aprs gonfler(20) et degonfler(30)",b);    
	b.deplacer(20,-30);
	trace("b aprs deplacer(20,-30)",b);
	trace("b.contient(200,100)?"+b.contient(200,100),b);
	
        a=new Attachee(150,250,25,20);
        trace("creation de a",a);
        a.gonfler(20);
        trace("a aprs gonfler(20)",a);
        a.deplacer(30,30);
        trace("a aprs dplacer(30,30)",a);
        a.monter(50);
        trace("a aprs monter(50)",a);
        trace("a.touche(b)?"+a.touche(b),a);
        trace("a.cordeTouchee(147,75)?"+a.cordeTouchee(147,75));
        
        c= new Coloree(100,200,45,Color.green);
        trace("Cration de c",c);
        c.degonfler(5);
        trace("c aprs degonfler(5)",c);
        
        f=new Face(250,100,40,Color.green);
	trace("cration de f",f);
	f.deplacer(50,50);
	trace("f aprs deplacer(50,50)",f);
    }
    
    public void paint(Graphics g) {
        setBackground(Color.white);
    	b.afficher(g,"b");
        a.afficher(g,"a");
        c.afficher(g,"c");
        f.afficher(g,"f");
    }
    
    public void mouseClicked(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mousePressed(MouseEvent e) {
        int x = e.getX(), y = e.getY();
        String pos=x+"@"+y+":";
        if (b.contient(x,y)){
            b.gonfler(10);
            trace(pos+"b.gonfler(10)",b);
        } else if (a.contient(x,y)) {
	    a.degonfler(10);
	    trace(pos+"a.degonfler(10)",a);
        } else if (a.cordeTouchee(x,y)) {
	    a.couperCorde();
	    trace(pos+"a.couperCorde()",a);
        } else if (c.contient(x,y)){
	    c.deplacer(10,10);
	    trace(pos+"c.dplacer(10,10)",c);
        } else if (f.contient(x,y)){
	    f.changeDAir();
	    trace(pos+"f.changeDAir",f);
        } else trace(pos+" dans le vide");
        repaint();
    }
    
    public void mouseReleased(MouseEvent e) {};
}
