/**
 * Ce programme sert  montrer la convertion de type avec hritage en Java
 * et l'utilisation du polymorphisme
 * @author Mohamed Lokbani 
 * @version 1.1
 */


/**
 * Classe de base: vehicule
 */

class vehicule {
    
    public double vitesse;
    public int nbre_passagers;
    
    /**
       constructeur
       @param v la vitesse du vhicule
       @param np nbre de passagers dans le vhicule
    */
    public vehicule(double v,int np) {
	vitesse = v;
	nbre_passagers = np;
    }
    /**
       pour afficher les membres private.
    */
    public void affiche() {
	System.out.println("vitesse: " + vitesse + " ; nbre_passagers: " + nbre_passagers);
    }
}

/**
 * Classe drive : avion
 * Hritage  partir de la classe de base : vehicule
 */
class avion extends vehicule {
    
    public int nbre_moteurs;
    
    /**
       constructeur
       @param nm le nombre de moteurs
       pour le constructeur de vhicule
       @param v la vitesse du vhicule
       @param np nbre de passagers dans le vhicule
    */
    
    public avion(int nm,double v,int np) {
	super(v,np); // appel au constructeur de vehicule
	nbre_moteurs = nm;
    }
    /**
       pour afficher les membres private.
    */
    public void affiche() {
	super.affiche(); // appel  la mthode affiche de la classe de base
	System.out.println("nbre de moteurs: " + nbre_moteurs);
    }
}



public class herconv {
    
    public static void main(String [] args) {
	vehicule v = new vehicule(200.,300);
	v.affiche(); // affiche de vhicule

	avion boeing = new avion(4,200.,300);
	boeing.affiche();

	v = boeing;

	v.vitesse = 500.6;

	// v.nbre_moteur = 5; // Erreur car champ nbre_moteur ne fait pas partie de vehicule

	v.affiche(); // affiche de avion, mme si v est du type vehicule, polymorphisme oblige!

	v = new vehicule(800.,500);

	// boeing = v; // Erreur! Un vehicule n'est pas forcmment un avion

	// boeing = (avion) v; // ok  la compilation, mais le programme plante  l'excution!

	System.exit(0);
    }
}	
